
/*************************** Includes ********************************/
#include <tjpbase.h>
#include <stdio.h>
/************************ End of Includes ****************************/

#define DebugSW		analog(7)
#define CDSnose		analog(1)
#define CDS_L		analog(5)
#define CDS_R		analog(6)
#define Nose_IR		analog(4)

int IR_processor();
int temp1;

/***************************** Main **********************************/
void main(void)
{

/* VT100 clear screen */ 
  char clear[]= "\x1b\x5B\x32\x4A\x04"; 

/* VT100 position cursor at (x,y) = (3,12) command is "\x1b[3;12H"*/
  char place[]= "\x1b[1;1H";	/*Home*/	

  init_analog();
  init_clocktjp();
  init_serial();

  IRE_ON; /*turn on IR emitters */

  printf("%s", clear);  
  printf("%s", place);
  
  printf("\tTitle\t\t_analog.c\n"
  "\tProgrammer\tJason Grzywna\n"
  "\tDate\t\tMarch, 2000\n"
  "\tVersion\t\t1.0\n\n");

  printf("TRANS AM SENSOR READINGS\n\n");
  printf("Left IR    Right IR    Bumper    Nose_IR    CDSnose    CDS_L    CDS_R\n"); 
		

  while(1)
  {
	//temp1 = IR_processor();
  /*
    Move cursor to data field position and print data
    The escape sequences control cursor position ESC[<x_pos>;<y_pos>H
  */
    printf("\x1b[10;1H    \b\b\b\b\b%d",LEFT_IR);
    printf("\x1b[10;13H   \b\b\b\b%d",RIGHT_IR);
    printf("\x1b[10;25H   \b\b\b\b%d",BUMPER);
    printf("\x1b[10;36H   \b\b\b\b%d",Nose_IR);
    printf("\x1b[10;47H   \b\b\b\b%d",CDSnose);
    printf("\x1b[10;58H   \b\b\b\b%d",CDS_L);
    printf("\x1b[10;69H   \b\b\b\b%d",CDS_R);
    //printf("\x1b[10;78H   \b\b\b\b%d\n\n\n\n",temp1);
    wait(50);

  }/*end while(1)*/
}
/***************************** End of Main **********************************/
int IR_processor(void)
{
	int IRout, IRout1, IRtemp, irLtemp, irRtemp, irL, irR;
		
	irL = analog(3);
	irR = analog(2);
	
	
	printf("\nIR Left - %d", irL);
	printf("\nIR Right - %d", irR);
		irLtemp = -irL;
		irRtemp = irR;
		IRtemp = (irLtemp + irRtemp);

	
	/*IRout1 = (IRtemp * 2.5);
	printf("\nIRout1 - %d", IRout1);*/ 				/* Scales to -100 -> 100 */
		
	if ((IRtemp < 12) && (IRtemp > -12)) /* || (IRtemp = 0))		/* Processes Depth is object is centered */		
	{ 
		if ((irL < 95) && (irR < 95))
		{
			IRout = 11;
		}
		else if ((irL < 105) && (irR < 105))
		{
			IRout = 22;
		}
		else if ((irL < 115) && (irR < 115))
		{
			IRout = 33;
		}
		else if ((irL < 124) && (irR < 124))
		{
			IRout = 44;
		}
		else if ((irL > 125) && (irR > 125))
		{
			IRout = 55;
			printf("CLOSE");
		}
	}
	else
	{
		IRout = IRtemp; /*(IRout1 / 10);*/
		printf("\n\nIRout!!! - %d", IRout);
	}
		
	
	return IRout;
}
