
#include <transam.h>
#include <stdio.h>

void avoidance();
int IR_procT();
int Accelerator(int);
void turn(int);
void turn_toward_ir();

int steering_center = 2500; /*THESE SHOULD BE GLOBAL*/
int far_left = 1500;
int far_right = 4000;
int current_speed = 0;
int spd_factorL, spd_factorR;
int irL, irR, turning_IR, d_of_turn, xx, yy, i, velocity;


void main(void)
{

	init_analog();
	init_motortjp();
	init_clocktjp();
	init_servotjp();
	
	NoSignal;
	
	START;
	
	IRE_ON;
	
	while(1)
	{
	avoidance();
	}	
	
}

void avoidance()
{
	
	turning_IR = IR_procT();
//	printf("\n%d\n", turning_IR);
	turn(turning_IR);
	velocity = Accelerator(-4);
	 if(FRONT_BUMP)
    {
      Accelerator(4); 	//reverse
      turn_toward_ir();	//turn towards largest IR signal
      wait(800);
    }
}


void turn(int dot)
{
	int degree;
	
	if (dot < 0)
	{
		if (dot <= -3)
		{
			degree = 1500;
			LeftSignal;
			
		}
		else if (dot <= -2)
		{
			degree = 1834;
			LeftSignal;
			
		}
		else if (dot <= -1)
		{
			degree = 2167;
			LeftSignal;
			
		}
	}
	else if (dot > 0)
	{
		if (dot >= 3)
		{
			degree = 4000;
			RightSignal;
			
		}
		else if (dot >= 2)
		{
			degree = 3500;
			RightSignal;
			
		}
		else if (dot >= 1)
		{
			degree = 3000;
			RightSignal;
			
		}
	}
	else
	{
		degree = 2500;
		NoSignal;
	}
	
	servo(0, degree);
	wait(100);	

}	

int IR_procT()
{

int irT_L, irT_R, t_diff;
int tL = 0;
int tR = 0;
irT_L = analog(3);
irT_R = analog(2);

printf("\t%d\n", irT_L);
printf("\t\t%d\n", irT_R);


if (irT_L > 95)
{
	if (irT_L > 95)
	{
		tL = 1;
		if (irT_L > 105)
		{
			tL = tL + 1;	
			if (irT_L > 115)
			{
				tL = tL + 1;
			}
		}
	}
}
else
	{
		tL = 0;
	}	


if (irT_R > 95)
{

	if (irT_R > 95)
	{
		tR = 1;
		if (irT_R > 105)
		{
			tR = tR + 1;
			if (irT_R > 115)
			{
				tR = tR + 1;
			}	
		}
	}
}	
else 
	{
		tR = 0;
	}	

t_diff = tL - tR;

//printf ("\ntL=%d\t", tL);
//printf ("tR=%d\t", tR);
//printf ("t_diff=%d", t_diff);

//if ( tL = tR )
//	return tR;
//else 
	return t_diff;
	
}


int Accelerator(int speed)
{
	int L_Speed, R_Speed;
	 
	
	
	if (speed <= 0)
	{
		if (speed <= -5)
		{
			L_Speed = -99;
			R_Speed = 4;
		}
		else if (speed <= -4)
		{
			L_Speed = -90;
			R_Speed = 14;
		}
		else if (speed <= -3)	
		{
			L_Speed = -80;
			R_Speed = 24;
			//perfect
		}
		else if (speed <= -2)
		{
			L_Speed = -70;
			R_Speed = 34;
			//near perfect
		}
		else if (speed <= -1)
		{
			L_Speed = -62;
			R_Speed = 44;
		}
		else if (speed <= 0)
		{
			L_Speed = 0;
			R_Speed = 0;
		}
	}
	else if (speed > 0)
	{
		if (speed >= 5)
		{
			L_Speed = -6;
			R_Speed = 99;
		}
		else if (speed >= 4)
		{
			L_Speed = -11;
			R_Speed = 94;
		}
		else if (speed >= 3)
		{
			L_Speed = -19;
			R_Speed = 84;
		}
		else if (speed >= 2)
		{
			L_Speed = -29;
			R_Speed = 74;
		}
		else if (speed >= 1)
		{
			L_Speed = -41;
			R_Speed = 64;
		}
		
	}
	else
	{
			L_Speed = 0;
			R_Speed = 0;
	}		

	
	
	if (speed < current_speed)
	{
		BrakeLight;
	}
	else 
		NoSignal;
		
	motorp(0, L_Speed);
	motorp(1, R_Speed);

	return current_speed;
}

void turn_toward_ir()
{

	int temp_L;
	int temp_R;
	
	temp_L = analog(3);
	temp_R = analog(2);

	if (temp_L > temp_R)
		{
			turn(-3);
			printf("-3");
		}
	else if (temp_R > temp_L)
		{
			turn(3);
			printf("3");
		}
}