#include <transam.h>
#include <stdio.h>


void track_follow();
int CDS_procT();
int Accelerator(int);
void turn(int);

int steering_center = 2500; /*THESE SHOULD BE GLOBAL*/
int far_left = 1650;
int far_right = 3800;
int current_speed = 0;
int spd_factorL, spd_factorR;
int irL, irR, turning_IR, d_of_turn, xx, yy, i, velocity;

void main(void)
{
	init_analog();
	init_motortjp();
	init_clocktjp();
	init_servotjp();
	
	NoSignal;
	
	START;
	
	IRE_ON;
	
	while(1)
	{
	track_follow();
	}
}

void track_follow()
{
	int temptrack;
	
	temptrack = CDS_procT();
	turn(temptrack);
	velocity = Accelerator(-3);
	


}


int CDS_procT()
{
	int C_left, C_right, C_nose, XYZ;
	
	
	
	C_left 	= analog(5);
	C_right = analog(6);
	C_nose	= analog(1);
	
	XYZ = 0;
	
	if ((C_left < 225) && (C_right < 215) && (C_nose < 185))
	{
		XYZ = 0;
	}
	else if (C_left > 220)
	{
		XYZ = -3;
	}
	else if (C_right > 180)
	{
		XYZ = 3;
	}
	else if (C_nose > 170)
	{
		XYZ = 0;
	}
	else if ((C_left < 225) && (C_right < 215))
	{
		XYZ = 0;
	}
	
	return XYZ;
}
	

void turn(int dot)
{
	int degree;
	
	if (dot < 0)
	{
		if (dot <= -3)
		{
			degree = 1650;
			LeftSignal;
			
		}
		else if (dot <= -2)
		{
			degree = 2000;
			LeftSignal;
			
		}
		else if (dot <= -1)
		{
			degree = 2300;
			LeftSignal;
			
		}
	}
	else if (dot > 0)
	{
		if (dot >= 3)
		{
			degree = 3800;
			RightSignal;
			
		}
		else if (dot >= 2)
		{
			degree = 2900;
			RightSignal;
			
		}
		else if (dot >= 1)
		{
			degree = 2700;
			RightSignal;
			
		}
	}
	else
	{
		degree = 2500;
		NoSignal;
	}
	
	servo(0, degree);	
	wait(125);

}	

int Accelerator(int speed)
{
	int L_Speed, R_Speed;
	 
	
	
	if (speed <= 0)
	{
		if (speed <= -5)
		{
			L_Speed = -99;
			R_Speed = 4;
		}
		else if (speed <= -4)
		{
			L_Speed = -90;
			R_Speed = 14;
		}
		else if (speed <= -3)	
		{
			L_Speed = -80;
			R_Speed = 24;
			//perfect
		}
		else if (speed <= -2)
		{
			L_Speed = -70;
			R_Speed = 34;
			//near perfect
		}
		else if (speed <= -1)
		{
			L_Speed = -62;
			R_Speed = 44;
		}
		else if (speed <= 0)
		{
			L_Speed = 0;
			R_Speed = 0;
		}
	}
	else if (speed > 0)
	{
		if (speed >= 5)
		{
			L_Speed = -6;
			R_Speed = 99;
		}
		else if (speed >= 4)
		{
			L_Speed = -11;
			R_Speed = 94;
		}
		else if (speed >= 3)
		{
			L_Speed = -19;
			R_Speed = 84;
		}
		else if (speed >= 2)
		{
			L_Speed = -29;
			R_Speed = 74;
		}
		else if (speed >= 1)
		{
			L_Speed = -41;
			R_Speed = 64;
		}
		
	}
	else
	{
			L_Speed = 0;
			R_Speed = 0;
	}		

	
	
	if (speed < current_speed)
	{
		BrakeLight;
	}
	else 
		NoSignal;
		
	motorp(0, L_Speed);
	motorp(1, R_Speed);

	return current_speed;
}

