#include <transam.h>
#include <stdio.h>

void off_track();
void on_track();
int IR_procT();
int CDS_procT();
int Accelerator(int);
void turn(int);
void turn_toward_ir();

int on_track_yes = 0;
int current_lane = 0;
int current_speed = 0;
int velocity, i, j, k;
int H_nose_min, H_L_min, H_R_min;
int L_nose_min, L_L_min, L_R_min;
int left_temp;
int right_temp;
int nosej;

H_L_min = 220;
H_R_min = 180;
H_nose_min = 170;

L_L_min = 200;
L_R_min = 175;
L_nose_min = 165;

void main(void)
{

	init_analog();
	init_motortjp();
	init_clocktjp();
	init_servotjp();
	
	NoSignal;
	START;
	IRE_ON;
	
	while(1)
	{
		//printf("\n%d", on_track_yes);	
		if (on_track_yes > 0)
		{
			on_track();
		}
		else 
			off_track();
	
	}
}

void on_track()
{
	int temptrack, z, noseO, left_cdsO, right_cdsO;
	int avoidance_ir;

	noseO 		= analog(1);
	left_cdsO 	= analog(5);
	right_cdsO	= analog(6);
	
	temptrack = CDS_procT();
	turn(temptrack);
	velocity = Accelerator(-3);
	
	if ((noseO <= 150) && (left_cdsO <= 170) && (right_cdsO <= 160))
	{
		z++;
	}
	else if ((noseO >= 170) || (left_cdsO >= 175) || (right_cdsO >= 165))
	{
		z = 0;
	}
	
	if (z >= 10)
	{
		on_track_yes = 0;
	}
	
	avoidance_ir = IR_procT();
	
	if ((avoidance_ir > 2) || (avoidance_ir < -2))
	{
		if (current_lane == 1)
		{
			turn(3);
			wait(350);
			on_track_yes = 0;
		}
		else if (current_lane == 2)
		{
			turn(-3);
			wait(350);
			on_track_yes = 0;
		}
	
	}
	
	
}


void off_track()
{
	int turning_IR, nose, left_cds, right_cds;
	
	turning_IR = IR_procT();
	turn(turning_IR);
	velocity = Accelerator(-2);
	current_lane = 0;
	
	if (FRONT_BUMP)
	{
		Accelerator(4);
		turn_toward_ir();
		wait(800);
	}
	
	nose 		= analog(1);
	left_cds 	= analog(5);
	right_cds	= analog(6);
		
	if (nose > 190)
	{
	
	//HazardSignal;
	
	Accelerator(-1);
	
	for ( i = 0; i < 3000; i++)
	{
		//printf("\tleft: %d", left_cds);
		//printf("\tright: %d", right_cds);
		//printf("\tnose: %d\n", nose);
					
		left_temp = analog(5);
		right_temp = analog(6);
		
		if (left_temp > 195)
		{
			//printf("see left");
			j = 0;
			nosej = analog(1);
			while (nosej > 195)
			{
			nosej = analog(1);
			}
			while ((nosej <= 195) && (j <= 2500))
			{
				//printf("\nJ= %d", j);
				//printf("\nNoseJ= %d", nosej); 
				
				
				nosej = analog(1);
				turn(3);
				j++;
			}
			
			
			if (nosej > 195)
					{
						on_track_yes = 1;
						current_lane = current_lane + 1;
						break;
					}
					
		}
		else if (right_temp > 180)
		{
			//printf("see right");
			k = 0;
			nosej = analog(1);
			while (nosej > 195)
			{
			nosej = analog(1);
			}
			while ((nosej <= 195) && (k <= 2500))
			{
				nosej = analog(1);
				//printf("\t\nNoseJ= %d", nosej);
				//printf("\t\nK= %d", k);
				
				turn(-3);
				k++;
			}
			
			if (nosej > 195)
			{
				on_track_yes = 1;
				current_lane = current_lane + 1;
				break;
			}
		}
	}
	}
}
	
int CDS_procT()
{

	int C_left, C_right, C_nose, XYZ;
		
	C_left 	= analog(5);
	C_right  = analog(6);
	C_nose	= analog(1);
	
	XYZ = 0;
	
	//if ((C_left < 225) && (C_right < 215) && (C_nose < 185))
	if ((C_left < L_L_min) && (C_right < L_R_min) && (C_nose < L_nose_min))
	{
		XYZ = 0;
	}
	else if (C_left > L_L_min)
	{
		XYZ = -3;
	}
	else if (C_right > L_R_min)
	{
		XYZ = 3;
	}
	else if (C_nose > L_nose_min)
	{
		XYZ = 0;
	}
	//else if ((C_left < 225) && (C_right < 215))
	else if ((C_left < L_L_min) && (C_right < L_R_min))
	{
		XYZ = 0;
	}
	
	return XYZ;
}

void turn(int dot)
{
	int degree;
	
	if (dot < 0)
	{
		if (dot <= -3)
		{
			degree = 1500;
			LeftSignal;
			
		}
		else if (dot <= -2)
		{
			degree = 1834;
			LeftSignal;
			
		}
		else if (dot <= -1)
		{
			degree = 2167;
			LeftSignal;
			
		}
	}
	else if (dot > 0)
	{
		if (dot >= 3)
		{
			degree = 4000;
			RightSignal;
			
		}
		else if (dot >= 2)
		{
			degree = 3500;
			RightSignal;
			
		}
		else if (dot >= 1)
		{
			degree = 3000;
			RightSignal;
			
		}
	}
	else
	{
		degree = 2500;
		NoSignal;
	}
	
	servo(0, degree);
	wait(100);	

}	

int IR_procT()
{

int irT_L, irT_R, t_diff;
int tL = 0;
int tR = 0;
irT_L = analog(3);
irT_R = analog(2);

//printf("\t%d\n", irT_L);
//printf("\t\t%d\n", irT_R);


if (irT_L > 95)
{
	if (irT_L > 95)
	{
		tL = 1;
		if (irT_L > 105)
		{
			tL = tL + 1;	
			if (irT_L > 115)
			{
				tL = tL + 1;
			}
		}
	}
}
else
	{
		tL = 0;
	}	


if (irT_R > 95)
{

	if (irT_R > 95)
	{
		tR = 1;
		if (irT_R > 105)
		{
			tR = tR + 1;
			if (irT_R > 115)
			{
				tR = tR + 1;
			}	
		}
	}
}	
else 
	{
		tR = 0;
	}	

t_diff = tL - tR;

//printf ("\ntL=%d\t", tL);
//printf ("tR=%d\t", tR);
//printf ("t_diff=%d", t_diff);

//if ( tL = tR )
//	return tR;
//else 
	return t_diff;
	
}


int Accelerator(int speed)
{
	
	int L_Speed, R_Speed;
	 
	
	
	if (speed <= 0)
	{
		if (speed <= -5)
		{
			L_Speed = -99;
			R_Speed = 4;
		}
		else if (speed <= -4)
		{
			L_Speed = -90;
			R_Speed = 14;
		}
		else if (speed <= -3)	
		{
			L_Speed = -80;
			R_Speed = 24;
			//perfect
		}
		else if (speed <= -2)
		{
			L_Speed = -70;
			R_Speed = 34;
			//near perfect
		}
		else if (speed <= -1)
		{
			L_Speed = -62;
			R_Speed = 44;
		}
		else if (speed <= 0)
		{
			L_Speed = 0;
			R_Speed = 0;
		}
	}
	else if (speed > 0)
	{
		if (speed >= 5)
		{
			L_Speed = -6;
			R_Speed = 99;
		}
		else if (speed >= 4)
		{
			L_Speed = -11;
			R_Speed = 94;
		}
		else if (speed >= 3)
		{
			L_Speed = -19;
			R_Speed = 84;
		}
		else if (speed >= 2)
		{
			L_Speed = -29;
			R_Speed = 74;
		}
		else if (speed >= 1)
		{
			L_Speed = -41;
			R_Speed = 64;
		}
		
	}
	else
	{
			L_Speed = 0;
			R_Speed = 0;
	}		

	
	
	if (speed < current_speed)
	{
		BrakeLight;
	}
	else 
		NoSignal;
		
	motorp(0, L_Speed);
   motorp(1, R_Speed);

	return current_speed;
}


void turn_toward_ir()
{

	int temp_L;
	int temp_R;
	
	temp_L = analog(3);
	temp_R = analog(2);

	if (temp_L > temp_R)
		{
			turn(-3);
			//printf("-3");
		}
	else if (temp_R > temp_L)
		{
			turn(3);
			//printf("3");
		}
	
}