/**********************
*	Title		Trans Am Avoidance
*	Programmer	Jason Grzywna
*	Date		March 1, 2000
*	Version 	1.1
*	
*	Description
*		A modification and revision of the well known TJPro
*		avoidance code. This avoidance code reads from IR
*		sensors and sends signals to the drivetrain controlling
*		DOT (direction of travel).
*
***********************/ 

#include <tjpbase.h>
#include <stdio.h>

void turn(void);


void main(void)
{
	int irdr, irdl, speedr, speedl; /* varibles */
	
	init_analog();
	init_motortjp();
	init_clocktjp();
	
	IRE_ON;							/* initialize emitters*/
	
	/* 	I'm leaving out a start routine for now...
		will add something here later				*/
		
	while(1)
	{
	
	irdr = RIGHT_IR;
	irdl = LEFT_IR;
	
	/* Range of IR sensors: Low 89 - High 130 */
	
	if (irdl > 100)
	{
		speedr = 19;
		speedl = -15;
		printf("STOP\n");
		wait(200);
	}
	else
	{
		speedr = 100;
		speedl = 100;
		printf("FWD\n");
	}	
	if (irdr > 100)
	{
		speedl = -15;
		speedr = 19;
		printf("STOP\n");
		wait(200);
	}
	else 
	{
		speedr = 100;
		speedl = 100;
		printf("FWD\n");
	}	
	if (irdr && irdl > 100)
	{
		printf("REVERSE\n");
		motorp(LEFT_MOTOR, -100);
      	motorp(RIGHT_MOTOR, -100);
      	wait(200);
      	turn();
      	printf("TURN\n");
    }
	else
	{
		speedr = 100;
		speedl = 100;
		printf("FWD\n");
	}	
	motorp(RIGHT_MOTOR, speedr);
	motorp(LEFT_MOTOR, speedl);
	

	
	wait(10);		/* standard is 35ms */
	}
}



/***********************
*	
*	Turn() imported directly from TJPAVOID.C
*
***********************/

void turn(void)
{
 int i;
 unsigned rand;

 rand = TCNT;

 if (rand & 0x0001)
 /*turn left*/
 {
   motorp(RIGHT_MOTOR, MAX_SPEED);
   motorp(LEFT_MOTOR, -MAX_SPEED);
 }
 else
 /*turn right*/
 {
   motorp(RIGHT_MOTOR, -MAX_SPEED);
   motorp(LEFT_MOTOR, MAX_SPEED);
 }

 i=(rand % 1024);
 if(i>250) wait(i); else wait(250);

}

